/*
   This file contains the subroutines for the Inputs
*/
byte key;

bool numpress = false; // Indicate that Number was pressed. Needs to be cleared to accept a new keypress

void ReactInt() {
  if (bitRead(interruptSource, 7) == 1) {
    ReadTouch();
    TouchButton();
  }
  if (bitRead(interruptSource, 6) == 1) {
    if (numpress) {
      if (InputMode == INPUT_ENTER_FREQ || SysStatus == INPUT_ENTER_AMPLITUDE || SysStatus == INPUT_ENTER_MODPARA1 || SysStatus == INPUT_ENTER_MODPARA2 || SysStatus == INPUT_ENTER_MODPARA3 || SysStatus == INPUT_ENTER_MODPARA4 || SysStatus == INPUT_ENTER_BURSTPARA1 || SysStatus == INPUT_ENTER_BURSTPARA2 || SysStatus == INPUT_ENTER_BURSTPARA3 || SysStatus == INPUT_ENTER_BURSTPARA4 || SysStatus == INPUT_ENTER_RAMPPARA1 || SysStatus == INPUT_ENTER_RAMPPARA2 || SysStatus == INPUT_ENTER_RAMPPARA3 || SysStatus == INPUT_ENTER_RAMPPARA4 || SysStatus == INPUT_DIG_PATTERN) {
        ReadKeyboard();
        UpdateDisplay();
      }
      else {
        Message(F("INFO: No Input-Target - Select a mode that expects data"), AMBER);
      }
    }
  }
  SysStatus = STATE_NORM_OP;
}


int ReadKeyboard() {
  Wire.requestFrom(KEYBD_ADR, 1);
  key = Wire.read();
  Wire.endTransmission();
  // key = Code to decode the byte "key" to a number and then call "num", IF the key pressed is not "*" or "#".
  if (key == 0xFF) {

  }
  if (key == 0xFF) {

  }
  else {
    num(key);
  }
}

void num(signed long n) {
  numpress = true; // Number has been pressed
  //Add a number
  keyboardInput = 10 * keyboardInput + n;
}



// Touch-Position Variables

uint16_t x, y;
uint8_t z;
// Adjusted value of the Touch-Coordinates to fit the grid
uint16_t cx, cy;

// This is calibration data for the raw touch data to the screen coordinates
#define TS_MINX 3800
#define TS_MAXX 100
#define TS_MINY 100
#define TS_MAXY 3750

/*
   Touch-Calibration Routine
*/

void TouchCalibration() {

}


void ReadTouch() {

  if (touch.touched()) {
    // read x & y & z;
    while (! touch.bufferEmpty()) {
      //      Serial.print(touch.bufferSize());
      touch.readData(&x, &y, &z);
      //      Serial.print("->(");
      //      Serial.print(x); Serial.print(", ");
      //      Serial.print(y); Serial.print(", ");
      //      Serial.print(z);
      //      Serial.println(")");
    }
    CalcPixelPos();
    touch.writeRegister8(STMPE_INT_STA, 0xFF); // reset all ints
  }
}

//

void CalcPixelPos() {
  cx = map(cx, TS_MINX, TS_MAXX, tft.width(), 0);
  cy = map(cy, TS_MINY, TS_MAXY, 0, tft.height());
}


void TouchButton() {
  switch (SysStatus) {
    case STATE_NORM_OP:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          SysStatus = STATE_ENTER_FREQ;
        }
        if (cy > 90 && cy < 140) {
          SysStatus = STATE_ENTER_AMPLITUDE;
        }
        if (cy > 150 && cy < 200) {
          SysStatus = STATE_ENTER_MODULATION_TYPE;
        }
        if (cy > 210 && cy < 260) {
          SysStatus = STATE_CONFIG_1;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_MODE_SELECT_2;
        }
      }
      if (cx < 290) {
        if (cy > 30 && cy < 110) {
          SysStatus = STATE_ENTER_FREQ;
        }
        if (cy > 115 && cy < 195) {
          SysStatus = STATE_ENTER_AMPLITUDE;
        }
        if (cy > 200 && cy < 320) {
          SysStatus = STATE_ENTER_MODULATION_TYPE;
        }
      }
      break;
    case STATE_MODE_SELECT_2:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          SysStatus = STATE_ADV_FUNCTIONS;
        }
        if (cy > 90 && cy < 140) {
          SysStatus = STATE_SIGPATH_CTRL;
        }
        if (cy > 150 && cy < 200) {

        }
        if (cy > 210 && cy < 260) {
          SysStatus = STATE_DEMO;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_NORM_OP;
        }
      }
      if (cx < 290) {
        if (cy > 30 && cy < 110) {
          SysStatus = STATE_ENTER_FREQ;
        }
        if (cy > 115 && cy < 195) {
          SysStatus = STATE_ENTER_AMPLITUDE;
        }
        if (cy > 200 && cy < 320) {
          SysStatus = STATE_ENTER_MODULATION_TYPE;
        }
      }
    case STATE_ADV_FUNCTIONS:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          SysStatus = STATE_ENTER_BURST;
        }
        if (cy > 90 && cy < 140) {
          SysStatus = STATE_ENTER_RAMP;
        }
        if (cy > 150 && cy < 200) {
          SysStatus = STATE_ADV_MODULATION;
        }
        if (cy > 210 && cy < 260) {
          SysStatus = STATE_ARBITRARY_WAVE;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_MODE_SELECT_2;
        }
      }
      if (cx < 290) {
        if (cy > 30 && cy < 110) {
        }
      }
      break;

    case STATE_ADV_MODULATION:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {

        }
        if (cy > 90 && cy < 140) {

        }
        if (cy > 150 && cy < 200) {

        }
        if (cy > 210 && cy < 260) {

        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_MODE_SELECT_2;
        }
      }
      if (cx < 290) {
      }
      break;
    case STATE_ARBITRARY_WAVE:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {

        }
        if (cy > 90 && cy < 140) {

        }
        if (cy > 150 && cy < 200) {

        }
        if (cy > 210 && cy < 260) {

        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_MODE_SELECT_2;
        }
      }
      if (cx < 290) {
        if (cy > 30 && cy < 110) {

        }
        if (cy > 115 && cy < 195) {

        }
        if (cy > 200 && cy < 320) {

        }
      }
      break;
    case STATE_SIGPATH_CTRL:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          SigPathAuto != SigPathAuto;
        }
        if (cy > 90 && cy < 140) {
          ExtSource != ExtSource;
          SetSignalSource(ExtSource);
        }
        if (cy > 150 && cy < 200) {
          ExtAM != ExtAM;
        }
        if (cy > 210 && cy < 260) {
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_MODE_SELECT_2;
        }
      }
      if (cx < 290) {
        if (cy > 30 && cy < 110) {
         // REPLACE THE COORDINATES WITH THE COORDINATE CORRESPONDING TO THE FILTER_MAP
        }
      }
      break;

    /*
     * *** CALIBRATION-MODE CONTROLS
    */
    case STATE_CALIBRATION:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          SysStatus = STATE_SIGSOURCE_CAL;
        }
        if (cy > 90 && cy < 140) {
          SysStatus = STATE_SIGPATH_CAL;
        }
        if (cy > 150 && cy < 200) {
          SysStatus = STATE_SIGPATH_COMP;
        }
        if (cy > 210 && cy < 260) {
          SysStatus = STATE_TOUCH_CAL;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_NORM_OP;
        }
      }
      break;
    case STATE_SIGSOURCE_CAL:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          //          SysStatus = STATE_ENTER_FREQ;
        }
        if (cy > 90 && cy < 140) {
          //          SysStatus = STATE_ENTER_AMPLITUDE;
        }
        if (cy > 150 && cy < 200) {
          //          SysStatus = STATE_ENTER_MODULATION_TYPE;
        }
        if (cy > 210 && cy < 260) {
          //          SysStatus = STATE_CONFIG;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_CALIBRATION;
        }
      }
      break;
    case STATE_SIGPATH_CAL:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          //          SysStatus = STATE_ENTER_FREQ;
        }
        if (cy > 90 && cy < 140) {
          //          SysStatus = STATE_ENTER_AMPLITUDE;
        }
        if (cy > 150 && cy < 200) {
          //          SysStatus = STATE_ENTER_MODULATION_TYPE;
        }
        if (cy > 210 && cy < 260) {
          //          SysStatus = STATE_CONFIG;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_CALIBRATION;
        }
      }
      break;
    case STATE_SIGPATH_COMP:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          //          SysStatus = STATE_ENTER_FREQ;
        }
        if (cy > 90 && cy < 140) {
          //          SysStatus = STATE_ENTER_AMPLITUDE;
        }
        if (cy > 150 && cy < 200) {
          //          SysStatus = STATE_ENTER_MODULATION_TYPE;
        }
        if (cy > 210 && cy < 260) {
          //          SysStatus = STATE_CONFIG;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_CALIBRATION;
        }
      }
      break;
    case STATE_TOUCH_CAL:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          //          SysStatus = STATE_ENTER_FREQ;
        }
        if (cy > 90 && cy < 140) {
          //          SysStatus = STATE_ENTER_AMPLITUDE;
        }
        if (cy > 150 && cy < 200) {
          //          SysStatus = STATE_ENTER_MODULATION_TYPE;
        }
        if (cy > 210 && cy < 260) {
          //          SysStatus = STATE_CONFIG;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_CALIBRATION;
        }
      }
      break;

    /*
     * *** CONFIG-CONTROLS
    */

    case STATE_CONFIG_1:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          //          SysStatus = ;
        }
        if (cy > 90 && cy < 140) {
          //          SysStatus = ;
        }
        if (cy > 150 && cy < 200) {
          //          SysStatus = ;
        }
        if (cy > 210 && cy < 260) {
          SysStatus = STATE_CONFIG_2;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_NORM_OP;
        }
      }
      // Put the SigPathCal-Screen here
      break;
    case STATE_CONFIG_2:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          //          SysStatus = ;
        }
        if (cy > 90 && cy < 140) {
          //          SysStatus = ;
        }
        if (cy > 150 && cy < 200) {
          //          SysStatus = ;
        }
        if (cy > 210 && cy < 260) {
          SysStatus = STATE_CONFIG_3;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_NORM_OP;
        }
      }
      break;
    case STATE_CONFIG_3:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          //          SysStatus = ;
        }
        if (cy > 90 && cy < 140) {
          //          SysStatus = ;
        }
        if (cy > 150 && cy < 200) {
          //          SysStatus = ;
        }
        if (cy > 210 && cy < 260) {
          SysStatus = STATE_CONFIG_4;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_NORM_OP;
        }
      }
      break;
    case STATE_CONFIG_4:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          //          SysStatus = ;
        }
        if (cy > 90 && cy < 140) {
          //          SysStatus = ;
        }
        if (cy > 150 && cy < 200) {
          //          SysStatus = ;
        }
        if (cy > 210 && cy < 260) {
          SysStatus = STATE_CONFIG_5;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_NORM_OP;
        }
      }
      break;
    case STATE_CONFIG_5:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          //          SysStatus = ;
        }
        if (cy > 90 && cy < 140) {
          //          SysStatus = ;
        }
        if (cy > 150 && cy < 200) {
          //          SysStatus = ;
        }
        if (cy > 210 && cy < 260) {
          SysStatus = STATE_CONFIG_6;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_NORM_OP;
        }
      }
      break;
    case STATE_CONFIG_6:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          //          SysStatus = ;
        }
        if (cy > 90 && cy < 140) {
          //          SysStatus = ;
        }
        if (cy > 150 && cy < 200) {
          //          SysStatus = ;
        }
        if (cy > 210 && cy < 260) {
          SysStatus = STATE_CONFIG_1;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_NORM_OP;
        }
      }
      break;

    case STATE_ENTER_FREQ:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          SysStatus = STATE_ENTER_FREQ;
          Freq = keyboardInput * 1000000000; // Multiply by 1 billion to scale the input-data to GHz
          SetFreq(Freq); // Update Frequency
          UpdateFreqArea = true;
          keyboardInput = 0;
        }
        if (cy > 90 && cy < 140) {
          SysStatus = STATE_ENTER_FREQ;
          Freq = keyboardInput * 1000000; // Multiply by 1 million to scale the input-data to MHz
          SetFreq(Freq);
          UpdateFreqArea = true;
          keyboardInput = 0;
        }
        if (cy > 150 && cy < 200) {
          SysStatus = STATE_ENTER_FREQ;
          Freq = keyboardInput * 1000; // Multiply by 1000 to scale the input-data to kHz
          SetFreq(Freq);
          UpdateFreqArea = true;
          keyboardInput = 0;
        }
        if (cy > 210 && cy < 260) {
          SysStatus = STATE_ENTER_FREQ;
          Freq = keyboardInput;
          SetFreq(Freq);
          UpdateFreqArea = true;
          keyboardInput = 0;
        }
        if (cy > 270 && cy < 320) {
          keyboardInput = 0;
          InputMode = INPUT_NO_INPUT;
          SysStatus = STATE_NORM_OP;
        }
      }
      if (cx < 290) {
        if (cy > 30 && cy < 110) {
          SysStatus = STATE_ENTER_FREQ;
        }
        if (cy > 115 && cy < 195) {
          SysStatus = STATE_ENTER_AMPLITUDE;
        }
        if (cy > 200 && cy < 320) {
          SysStatus = STATE_ENTER_MODULATION_TYPE;
        }
      }

    case STATE_ENTER_AMPLITUDE:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          SysStatus = STATE_ENTER_AMPLITUDE;
          OUTPUT_dBm = keyboardInput + OUTPUT_DBM_OFFSET; // Multiply by 1 billion to scale the input-data to GHz
          SetAmplitude(OUTPUT_dBm); // Update Amplitude
          AmplitudeModeDB = true;
          UpdateAmpArea = true;
          keyboardInput = 0;
        }
        if (cy > 90 && cy < 140) {
          SysStatus = STATE_ENTER_AMPLITUDE;
          OUTPUT_dBm = (0 - keyboardInput) * OUTPUT_DBM_OFFSET; // Multiply by 1 million to scale the input-data to MHz
          SetAmplitude(OUTPUT_dBm); // Update Amplitude
          AmplitudeModeDB = true;
          UpdateAmpArea = true;
          keyboardInput = 0;
        }
        if (cy > 150 && cy < 200) {
          SysStatus = STATE_ENTER_AMPLITUDE;
          //          Output_dBm = CODE TO CALCULATE THE AMPLITUDE FROM mV to dBm;
          SetAmplitude(OUTPUT_dBm); // Update Amplitude
          AmplitudeModeDB = false;
          UpdateAmpArea = true;
          keyboardInput = 0;
        }
        if (cy > 210 && cy < 260) {
          // SoftButton not used - Nothing to do here
        }
        if (cy > 270 && cy < 320) {
          keyboardInput = 0;
          InputMode = INPUT_NO_INPUT;
          SysStatus = STATE_NORM_OP;
        }
      }
      if (cx < 290) {
        if (cy > 30 && cy < 110) {
          SysStatus = STATE_ENTER_FREQ;
        }
        if (cy > 115 && cy < 195) {
          SysStatus = STATE_ENTER_AMPLITUDE;
        }
        if (cy > 200 && cy < 320) {
          SysStatus = STATE_ENTER_MODULATION_TYPE;
        }
      }

    case STATE_ENTER_MODULATION_TYPE:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          SysStatus = STATE_ENTER_AM_PARAMETERS;
        }
        if (cy > 90 && cy < 140) {
          SysStatus = STATE_ENTER_FM_PARAMETERS;
        }
        if (cy > 150 && cy < 200) {
          SysStatus = STATE_ENTER_PM_PARAMETERS;
        }
        if (cy > 210 && cy < 260) {
          // Enable / Disable Modulation
          ModulationEnable != ModulationEnable;
          keyboardInput = 0;
        }
        if (cy > 270 && cy < 320) {
          keyboardInput = 0;
          InputMode = INPUT_NO_INPUT;
          SysStatus = STATE_NORM_OP;
        }
      }
      if (cx < 290) {
        if (cy > 30 && cy < 110) {
          SysStatus = STATE_ENTER_FREQ;
        }
        if (cy > 115 && cy < 195) {
          SysStatus = STATE_ENTER_AMPLITUDE;
        }
        if (cy > 200 && cy < 320) {
          SysStatus = STATE_ENTER_MODULATION_TYPE;
        }
      }
      break;

    default:
      if (cx > 330) {
        if (cy > 30 && cy < 80) {
          SysStatus = STATE_ENTER_FREQ;
        }
        if (cy > 90 && cy < 140) {
          SysStatus = STATE_ENTER_AMPLITUDE;
        }
        if (cy > 150 && cy < 200) {
          SysStatus = STATE_ENTER_MODULATION_TYPE;
        }
        if (cy > 210 && cy < 260) {
          SysStatus = STATE_CONFIG_1;
        }
        if (cy > 270 && cy < 320) {
          SysStatus = STATE_MODE_SELECT_2;
        }
      }
      if (cx < 290) {
        if (cy > 30 && cy < 110) {
          SysStatus = STATE_ENTER_FREQ;
        }
        if (cy > 115 && cy < 195) {
          SysStatus = STATE_ENTER_AMPLITUDE;
        }
        if (cy > 200 && cy < 320) {
          SysStatus = STATE_ENTER_MODULATION_TYPE;
        }
      }
      break;
  }
}

