/* *** FUNCTIONS THAT CONCERN THE NVRAM ***
 *  NVRAM is located on the Analog-Board, has a size of 2KBytes and contains: 
 *  - CAL-Data
 *  - User-Config
 *  - Setup-Data
 *  - Sweep-Configurations
 *  
 *  
 *  Memory-Map: 
 *  0x000 - 0x0F0 = CAL-DATA: 12bit DAC-Calibration Data for PWR_SET-DAC is stored for every 25MHz-Step Starting at 0MHz and going up to 3GHz (120 16bit-Words)
 *  0x0F2 - 0x1E2 = CAL-DATA: 12bit DAC-Calibration Data for AGC_ATTEN_BIAS is stored for every 25MHz-Step Starting at 0MHz and going up to 3GHz (120 16bit Words)
 *  0x400 - 0x5AE = User-Config / User-Data
 *  0x5B0 - 0x5FE = System Configuration / Setup-Data / Touch Calibration-Data. If 0x5B0 is set to 0xFFFF, the System is being started for the first time. 
 *  0x600 - 0x7FE = Sweep-Settings
 */

const byte NVRAM_ADDR = 0x50; // FM24C16 NV-RAM sitting at Address 0x50 with all Address-Lines pulled LOW - FM24CL16 has always the Address 0x50

void WriteNVData(int NV_DATA, int NV_ADDR){
  
}

int ReadNVData(int NV_ADDR){
  
}

void ReadCalData(){
  
}

